
package com.bd.framework.accessimpl;

import com.bd.framework.accessapi.CreateAccess;
import com.bd.framework.util.HibernateUtil;

import org.hibernate.HibernateException;
import org.hibernate.Session;



/**
 * <p>
 * Saves a new entity. 
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 */
public class CreateAccessImpl<T> extends AccessBase implements CreateAccess<T> {

    private T entity;

    public T getEntity() {
        return entity;
    }

    public void setEntity(T entity) {
        this.entity = entity;
    }


    public void performExecute() throws HibernateException {
        Session session = HibernateUtil.currentSession();
        session.save(entity);
    }


} 