
package com.bd.framework.accessimpl;

import org.hibernate.HibernateException;
import org.hibernate.Session;

import com.bd.framework.accessapi.DeleteAccess;
import com.bd.framework.util.HibernateUtil;

/**
 * <p>
 * Removes an entity. 
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 */
public class DeleteAccessImpl<T> extends AccessBase implements DeleteAccess<T> {

    private T entity;

    public T getEntity() {
        return entity;
    }

    public void setEntity(T entity) {
        this.entity = entity;
    }


    public void performExecute() throws HibernateException {
        Session session = HibernateUtil.currentSession();
        session.delete(entity);
    }


} 