
package com.bd.framework.accessimpl;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

import com.bd.framework.accessapi.FindByQueryAccess;
import com.bd.framework.util.HibernateUtil;

/**
 * <p>
 * Implementation of Access command FindByQueryAccess. 
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 */
public class FindByQueryAccessImpl<T> extends AccessBase implements FindByQueryAccess<T> {

    private String query;
    private Map parameters;
    
    public void setQuery(String aQuery) {
        query = aQuery;
    }
    
    public void setParameters(Map map) {
        parameters = map;
    }

    private List<T> result;

    public List<T> getResult() {
        return this.result;
    }

    @SuppressWarnings("unchecked")
    public void performExecute() throws HibernateException {
        Session session = HibernateUtil.currentSession();
        Query q = session.createQuery(query);
        if (parameters != null) {
            for (Iterator iter = parameters.keySet().iterator(); iter.hasNext();) {
                String name = (String) iter.next();
                q.setParameter(name, parameters.get(name));             
            }
        }
        this.result = q.list();
    }

} 